module WechatClient
  module Apis
    module Getting

      #获取接口调用凭据

      def server_ip
        "https://api.weixin.qq.com/cgi-bin/getcallbackip?access_token=#{_access_token_}"
      end

      def access_token
        "https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid=#{@options.app_id}&secret=#{@options.app_secret}"
      end

      def __access_token__
        # for debug
        "https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid=#{@options.app_id}&secret=#{@options.app_secret}"
      end

      #发送消息

      def send_message
        "https://api.weixin.qq.com/cgi-bin/message/custom/send?access_token=#{_access_token_}"
      end

      #素材管理

      #用户管理

      def auth_access_token
        "https://api.weixin.qq.com/sns/oauth2/access_token?appid=#{@options.app_id}&secret=#{@options.app_secret}&grant_type=authorization_code&"
      end

      def base_info
        "https://api.weixin.qq.com/cgi-bin/user/info?access_token=#{_access_token_}&lang=zh_CN&"
      end

      def auth_info
        "https://api.weixin.qq.com/sns/userinfo?lang=zh_CN&"
      end

      def auth_access_token_validation
        "https://api.weixin.qq.com/sns/auth?"
      end

      def refresh_auth_access_token
        "https://api.weixin.qq.com/sns/oauth2/refresh_token?appid=#{@options.app_id}&grant_type=refresh_token&"
      end

      #菜单管理

      def menus
        "https://api.weixin.qq.com/cgi-bin/menu/get?access_token=#{_access_token_}"
      end

      def delete_menus
        "https://api.weixin.qq.com/cgi-bin/menu/delete?access_token=#{_access_token_}"
      end

      #账户管理

      #jsapi

      def jsapi_ticket
        "https://api.weixin.qq.com/cgi-bin/ticket/getticket?access_token=#{_access_token_}&type=jsapi"
      end

      def __jsapi_ticket__
        "https://api.weixin.qq.com/cgi-bin/ticket/getticket?access_token=#{_access_token_}&type=jsapi"
      end
    end
  end
end
