require 'wechat_client/cache_store/base_store'

module WechatClient
  module CacheStore
    class RedisStore < BaseStore
      def exists key
        @client.exists(key)
      end

      def delete key
        @client.del(key)
      end

      def cache_write key, mar
        @client.multi do
          @client.set(key, mar)
          @client.expire(key, 60*60)
        end
      end

      def cache_read key
        @client.get(key)
      end
    end
  end
end
